if select(2, UnitClass("player")) ~= "PALADIN" then return end
local GetPlayerBuffName = GetPlayerBuffName
local BR
local GetSpellInfo = GetSpellInfo
local IsEquippedItem = IsEquippedItem
local UnitCreatureType = UnitCreatureType
local UnitAttackSpeed = UnitAttackSpeed
local GetShieldBlock = GetShieldBlock
local math_floor = math.floor
local string_match = string.match
local tonumber = tonumber
local select = select

--No base increase: Avenger's Shield, Holy Shield, Consecration, Holy Shock

function DrDamage:PlayerData()
	
	--General
	self.Calculation["PALADIN"] = function( calculation, ActiveAuras, BuffTalentRanks, spell, baseSpell )
		if not baseSpell.Melee then
			if baseSpell.SpellAPBonus then
				calculation.AP = self:GetAP()
				calculation.minDam = calculation.minDam + (calculation.AP * baseSpell.SpellAPBonus)
				calculation.maxDam = calculation.maxDam + (calculation.AP * baseSpell.SpellAPBonus)
			end
		end
	end
	
	--Talents
	self.Calculation["One-Handed Weapon Specialization"] = function( calculation, value )
		if self:GetNormM() == 2.4 then
			if calculation.wDmgM then
				calculation.wDmgM = calculation.wDmgM * (1 + value)
			else
				calculation.dmgM = calculation.dmgM * (1 + value)
			end
		end
	end	
	self.Calculation["Two-Handed Weapon Specialization"] = function( calculation, value )
		if self:GetNormM() == 3.3 then
			if calculation.wDmgM then
				calculation.wDmgM = calculation.wDmgM * (1 + value)
			else
				calculation.dmgM = calculation.dmgM * (1 + value)
			end
		end
	end		
	self.Calculation["Crusade"] = function( calculation, talentValue )
		if not calculation.healingSpell then
			local targetType = UnitCreatureType("target")
			
			if BR and targetType and BR:HasReverseTranslation( targetType ) then
				targetType = BR:GetReverseTranslation( targetType )
			end	
			
			if targetType == "Undead"
			or targetType == "Demon"
			or targetType == "Humanoid"
			or targetType == "Elemental" then
				calculation.dmgM = calculation.dmgM * ( 1 + talentValue )
			end
		end
	end
	
	--Spells
	self.Calculation["Improved Holy Shield"] = function( calculation, talentValue )
		calculation.sHits = calculation.sHits + talentValue * 2
		calculation.spellDmgM = calculation.spellDmgM + talentValue * 0.1
		calculation.dmgM = calculation.dmgM * ( 1 + talentValue * 0.1 )
	end	
	self.Calculation["Flash of Light"] = function( calculation, ActiveAuras )
		--Redemption Flash of Light Bonus
		if self:GetSetAmount( "Redemption Gloves" ) >= 1 then
			calculation.critPerc = calculation.critPerc + 2
		end
		if self:HasGlyph(54936) then
			calculation.critPerc = calculation.critPerc + 5
		end
	end
	self.Calculation["Crusader Strike"] = function( calculation )
		--Vindication Gauntlets
		if self:GetSetAmount( "Vindication Gloves" ) >= 1 then
			calculation.dmgM = calculation.dmgM * 1.05
		end
	end
	self.Calculation["Shield of Righteousness"] = function( calculation )
		local bv = (GetShieldBlock() * 1.3)
		calculation.minDam = calculation.minDam + bv 
		calculation.maxDam = calculation.maxDam + bv
	end
	self.Calculation["Avenger's Shield"] = function( calculation, _, _, baseSpell )
		if self:HasGlyph(54930) then
			calculation.dmgM = calculation.dmgM * 2
			baseSpell.chainFactor = nil
		end
	end
	self.Calculation["Exorcism"] = function( calculation )
		local targetType = UnitCreatureType("target")
        
		if BR and targetType and BR:HasReverseTranslation( targetType ) then
			targetType = BR:GetReverseTranslation( targetType )
		end	
		if targetType == "Undead" or targetType == "Demon" then
			calculation.critPerc = 100
		end
		if self:HasGlyph(54934) then
			calculation.dmgM = calculation.dmgM * 1.2
		end
	end
	self.Calculation["Hammer of the Righteous"] = function( calculation, _, _, baseSpell )
		if self:HasGlyph(63219) then
			baseSpell.WeaponDamage = 16 --4 x 4 targets
		end
	end
	
	--Seals and judgements
	self.Calculation["Seal of Righteousness"] = function ( calculation )
		calculation.spellDmg = calculation.spellDmg + GetSpellBonusDamage(2)
	end
	self.DmgCalculation["Seal of Righteousness"] = function( calculation, _, _, spell )
		local spd = self:GetWeaponSpeed()
		local cspd = UnitAttackSpeed("player")
		--local min, max = self:WeaponDamage(calculation, true)
		--local _, data = self:CasterCalc( "Judgement of Righteousness", spell.Rank, true )
		
		calculation.minDam = spd * ( 0.022 * ( calculation.AP ) + 0.044 * ( calculation.spellDmg ) )
		calculation.maxDam = calculation.minDam --Min and max damage is the same
		calculation.Hits = floor(120/cspd) --Average damage per hit based on 2 minute duration
	end
	--self.DmgCalculation["Seal of Command"] = function( calculation, _, _, spell )
		--local _, data = self:CasterCalc( "Judgement of Command", spell.Rank, true )
		--local bonus = 0.29 * GetSpellBonusDamage(2)
		--calculation.minDam = bonus + 0.29 * calculation.spellDmg
		--calculation.maxDam = bonus + 0.29 * calculation.spellDmg
		--calculation.spellDmg = bonus
		--calculation.dmgM = data.DmgM
	--end
	self.Calculation["Judgement of Command"] = function ( calculation )
		calculation.AP = self:GetAP()
		local cspd = UnitAttackSpeed("player")
		local mMin, mMax = DrDamage:WeaponDamage( calculation, false )
		
		calculation.minDam = calculation.minDam + ( mMin * 0.3)-- + ( calculation.AP * 0.2 ) --DALLYTEMP
		calculation.maxDam = calculation.maxDam + ( mMax * 0.3)-- + ( calculation.AP * 0.2 )
	end
	self.Calculation["Judgement of Blood"] = function ( calculation )
		calculation.AP = self:GetAP()
		local cspd = UnitAttackSpeed("player")
		local mMin, mMax = DrDamage:WeaponDamage( calculation, cspd )
		
		calculation.minDam = calculation.minDam + ( mMin * 0.45)-- + ( calculation.AP * 0.2 )
		calculation.maxDam = calculation.maxDam + ( mMax * 0.45)-- + ( calculation.AP * 0.2 )
		calculation.Hits = floor(120/cspd)
	end
	self.Calculation["Judgement of the Martyr"] = function ( calculation )
		calculation.AP = self:GetAP()
		local cspd = UnitAttackSpeed("player")
		local mMin, mMax = DrDamage:WeaponDamage( calculation, cspd )
		
		calculation.minDam = calculation.minDam + ( mMin * 0.45)-- + ( calculation.AP * 0.2 )
		calculation.maxDam = calculation.maxDam + ( mMax * 0.45)-- + ( calculation.AP * 0.2 )
		calculation.Hits = floor(120/cspd)
	end

	self.Calculation["Judgement of Vengeance"] = function( calculation, ActiveAuras )
		if ActiveAuras["Holy Vengeance"] then
			calculation.spellDmgM = calculation.spellDmgM * ActiveAuras["Holy Vengeance"]
			calculation.minDam = calculation.minDam * ActiveAuras["Holy Vengeance"]
			calculation.maxDam = calculation.maxDam * ActiveAuras["Holy Vengeance"]
		end
	end
	--[[self.Calculation["Seal of Corruption"] = function ( calculation, _, _, spell )
		calculation.AP = self:GetAP()
		
		calculation.minDam = spell.extraDotDmg + ( calculation.AP * 0.192 )
		calculation.maxDam = spell.extraDotDmg + ( calculation.AP * 0.192 )
	end]]--
	self.Calculation["Judgement of Corruption"] = function( calculation, ActiveAuras )
		if ActiveAuras["Blood Corruption"] then
			calculation.spellDmgM = calculation.spellDmgM * ActiveAuras["Blood Corruption"]
			calculation.minDam = calculation.minDam * ActiveAuras["Blood Corruption"]
			calculation.maxDam = calculation.maxDam * ActiveAuras["Blood Corruption"]
		end
	end		
	
		
	--Relic slot items
	--Libram of the Eternal Rest, Libram of Resurgence
	self.RelicSlot["Consecration"] = { 27917, 47, 40337, 141 }
	--Libram of Righteous Power, Libram of Radiance
	self.RelicSlot["Crusader Strike"] = { 31033, 36, 40191, 115.5 }
	--Libram of Souls Redeemed, Libram of Light, Blessed Book of Nagrand, Libram of Divinity,
	self.RelicSlot["Flash of Light"] = { 28592, 89, 23006, 83, 25644, 79, 23201, 53, }
	--Libram of the Lightbringer, Libram of the Resolute, Libram of Tolerance
	self.RelicSlot["Holy Light"] = { 28296, 87, 45436, 160, 40268, 141 }
	--Libram of Divine Purpose
	self.RelicSlot["Judgement of Righteousness"] = { 33504, 94 }
	--Libram of Wracking
	self.RelicSlot["Exorcism"] = { 28065, 120 }
	--Libram of Wracking
	self.RelicSlot["Holy Wrath"] = { 28065, 120 }
	--Libram of Discord
	self.RelicSlot["Divine Storm"] = { 45510, 235 }
    
	--Set bonuses
	
	--Sets
	--PvP Glove Bonuses
	self.SetBonuses["Redemption Gloves"] = { 27703, 31614, 31993, 32021, 33696, 33723, 40918, 40925, 40926, } --PvP Healer Gloves
    self.SetBonuses["Vindication Gloves"] = { 35089, 40798, 40802, 40805, } --PvP DPS Gloves
    --PvP Healing Set
	self.SetBonuses["Gladiator's Redemption"] = { 31613, 31614, 31616, 31618, 31619, 32020, 32021, 32022, 32023, 32024, 33722, 33723, 33724, 33725, 33726, 
        40898, 40918, 40930, 40936, 40960, 40904, 40925, 40931, 40937, 40961, 4090540926, 40932, 40938, 40962 }
    --T7
	self.SetBonuses["Redemption Regalia"] = { 39628, 39629, 39630, 39631, 39632, 40569, 40570, 40571, 40572, 40573 }
    self.SetBonuses["Redemption Plate"] = { 39638, 39639, 39640, 39641, 39642, 40579, 40580, 40581, 40583, 40584 }
    self.SetBonuses["Redemption Battlegear"] = { 39633, 39634, 39635, 39636, 39637, 40574, 40575, 40576, 40577, 40578 }
    --T8
    self.SetBonuses["Aegis Regalia"] = { 45370, 45371, 45372, 45373, 45374, 46178, 46179, 46180, 46181, 46182 }
    self.SetBonuses["Aegis Plate"] = { 45381, 45382, 45383, 45384, 45385, 46173, 46174, 46175, 46176, 46177 }
    self.SetBonuses["Aegis Battlegear"] = { 45375, 45376, 45377, 45379, 45380, 46152, 46153, 46154, 46155, 46156 }
	
	--Effects
	self.SetBonuses["Seal of Blood"] = function( calculation )
		if self:GetSetAmount( "Aegis Plate" ) >= 2 then
			calculation.dmgM = calculation.dmgM * 1.1
		end	
	end
	self.SetBonuses["Seal of Vengeance"] = self.SetBonuses["Seal of Blood"]
    self.SetBonuses["Seal of Righteousness"] = self.SetBonuses["Seal of Blood"]
    self.SetBonuses["Seal of the Martyr"] = self.SetBonuses["Seal of Blood"]
    self.SetBonuses["Seal of Corruption"] = self.SetBonuses["Seal of Blood"]
	self.SetBonuses["Holy Shock"] = function( calculation )
		if calculation.healingSpell and self:GetSetAmount( "Gladiator's Redemption" ) >= 4 then
			calculation.dmgM = calculation.dmgM * 1.3
		end
        if self:GetSetAmount( "Redemption Regalia" ) >= 2 then
            calculation.critPerc = calculation.critPerc + 10
        end
        if calculation.healingSpell and self:GetSetAmount( "Aegis Regalia" ) >= 2 then
            calculation.critM = calculation.critM * 1.15 --applied as a DoT
        end
	end
    self.SetBonuses["Hammer of the Righteous"] = function( calculation )
        if self:GetSetAmount( "Redemption Plate" ) >= 2 then
            calculation.dmgM = calculation.dmgM * 1.1
        end
    end
    self.SetBonuses["Crusader Strike"] = function( calculation )
        if self:GetSetAmount( "Aegis Battlegear" ) >= 4 then
            calculation.critPerc = calculation.critPerc + 10
        end
    end
    self.SetBonuses["Divine Storm"] = function( calculation )
        if self:GetSetAmount( "Redemption Battleplate" ) >= 2 then
            calculation.dmgM = calculation.dmgM * 1.1
        end
        if self:GetSetAmount( "Aegis Battlegear" ) >= 4 then
            calculation.critPerc = calculation.critPerc + 10
        end
    end
    self.SetBonuses["Exorcism"] = function( calculation )
        if self:GetSetAmount( "Aegis Battlegear" ) >= 2 then
            calculation.dmgM = calculation.dmgM * 1.1
        end
    end
    self.SetBonuses["Hammer of Wrath"] = self.SetBonuses["Exorcism"]
	
	--AURA
	--Seal of Righteousness
	--Seal of Command
	--Seal of Blood
	--Seal of Vengeance
	--Light's Grace
	
	--Divine Favor

	--Holy Vengeance

	self.PlayerAura[GetSpellInfo(21084)] = { ModType = "Update" }
	self.PlayerAura[GetSpellInfo(20375)] = { ModType = "Update" }
	self.PlayerAura[GetSpellInfo(31892)] = { ModType = "Update" }
	self.PlayerAura[GetSpellInfo(31801)] = { ModType = "Update" }
	self.PlayerAura[GetSpellInfo(31834)] = { ModType = "Update", Spell = GetSpellInfo(635) }

	self.PlayerAura[GetSpellInfo(20216)] = { Spell = { GetSpellInfo(19750), GetSpellInfo(635), GetSpellInfo(20473), }, ModType = "critPerc", Value = 100, }
	
	self.TargetAura[GetSpellInfo(31803)] = { ModType = "ActiveAura", ActiveAura = "Holy Vengeance", Value = 0.1, Apps = 5, }
	self.TargetAura[GetSpellInfo(53742)] = { ModType = "ActiveAura", ActiveAura = "Blood Corruption", Value = 0.1, Apps = 5, }
	
	self.spellInfo = {
		[GetSpellInfo(31935)] = { 
					["Name"] = "Avenger's Shield",
					[0] = { School = { "Holy", "Physical" }, SpellAPBonus = 0.07, canCrit = true, bonusFactor = 0.07, chainFactor = 1, Cooldown = 30, },
					[1] = { 440, 536, spellLevel = 50, },
					[2] = { 601, 733, spellLevel = 60, }, 
					[3] = { 796, 972, spellLevel = 70, }, 
					[4] = { 913, 1115, spellLevel = 75, }, 
					[5] = { 1100, 1344, spellLevel = 80, }, 
		},
		[GetSpellInfo(2812)] = { 
					["Name"] = "Holy Wrath",
					[0] = { School = "Holy", SpellAPBonus = 0.07, canCrit = true, bonusFactor = 0.07, BaseIncrease = true },
					[1] = { 399, 471, 6, 7, spellLevel = 50, },
					[2] = { 551, 649, 7, 8, spellLevel = 60, },
					[3] = { 777, 913, 2, 3, spellLevel = 69, },
					[4] = { 857, 1007, 0, 0, spellLevel = 72, },
					[5] = { 1050, 1234, 0, 0, spellLevel = 78, },
		},
		[GetSpellInfo(20925)] = { 
					["Name"] = "Holy Shield",
					[0] = { School = "Holy", bonusFactor = 0.20, NoDPS = true, NoDoom = true, sHits = 8, },
					[1] = { 79, 79, spellLevel = 40, },
					[2] = { 116, 116, spellLevel = 50, },
					[3] = { 157, 157, spellLevel = 60, },
					[4] = { 208, 208, spellLevel = 70, },
					[5] = { 235, 235, spellLevel = 75, },
					[6] = { 274, 274, spellLevel = 80, },
		},
		[GetSpellInfo(635)] = { 
					["Name"] = "Holy Light",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 2.5, BaseIncrease = true, },
					[1] = { 50, 60, 3, 4, spellLevel = 1, },
					[2] = { 96, 116, 5, 6, spellLevel = 6, },
					[3] = { 203, 239, 8, 9, spellLevel = 14, },
					[4] = { 397, 455, 12, 12, spellLevel = 22, },
					[5] = { 628, 708, 15, 16, spellLevel = 30, },
					[6] = { 894, 998, 19, 19, spellLevel = 38, },
					[7] = { 1209, 1349, 23, 23, spellLevel = 46, },
					[8] = { 1595, 1777, 26, 26, spellLevel = 54, },
					[9] = { 2034, 2266, 29, 29, spellLevel = 60, },
					[10] = { 2232, 2486, 32, 32, spellLevel = 62, },
					[11] = { 2818, 3138, 0, 0, spellLevel = 70, },
					[12] = { 4199, 4677, 0, 0, spellLevel = 75, },
					[13] = { 4888, 5444, 0, 0, spellLevel = 80, },
		},	
		[GetSpellInfo(24275)] = {
					["Name"] = "Hammer of Wrath",
					[0] = { School = { "Holy", "Physical" }, canCrit = true, SpellAPBonus = 0.15, bonusFactor = 0.15, Cooldown = 6, BaseIncrease = true, },
					[1] = { 351, 387, 12, 12, spellLevel = 44, },
					[2] = { 459, 507, 13, 14, spellLevel = 52, },
					[3] = { 570, 628, 15, 16, spellLevel = 60, },
					[4] = { 733, 809, 7, 7, spellLevel = 68, },
					[5] = { 878, 970, 0, 0, spellLevel = 74, },
					[6] = { 1139, 1257, 0, 0, spellLevel = 80, },
		},
		[GetSpellInfo(879)] = {
					["Name"] = "Exorcism",
					[0] = { School = "Holy", canCrit = true, SpellAPBonus = 0.15, bonusFactor = 0.15, Cooldown = 15, BaseIncrease = true, },
					[1] = { 96, 110, 6, 6, spellLevel = 20, },
					[2] = { 173, 195, 8, 8, spellLevel = 28, },
					[3] = { 250, 280, 10, 10, spellLevel = 36, },
					[4] = { 350, 394, 12, 12, spellLevel = 44, },
					[5] = { 452, 506, 14, 14, spellLevel = 52, },
					[6] = { 564, 628, 16, 16, spellLevel = 60, },
					[7] = { 687, 765, 7, 7, spellLevel = 68, },
					[8] = { 787, 877, 0, 0, spellLevel = 73, },
					[9] = { 1028, 1146, 0, 0, spellLevel = 79, },
		},
		[GetSpellInfo(26573)] = {
					["Name"] = "Consecration",
					[0] = { School = "Holy", castTime = 8, SpellAPBonus = 0.32, bonusFactor = 0.32, sTicks = 1, },
					[1] = { 72, 72, spellLevel = 20, },
					[2] = { 136, 136, spellLevel = 30, },
					[3] = { 224, 224, spellLevel = 40, },
					[4] = { 336, 336, spellLevel = 50, },
					[5] = { 448, 448, spellLevel = 60, },
					[6] = { 576, 576, spellLevel = 70, },
					[7] = { 696, 696, spellLevel = 75, },
					[8] = { 904, 904, spellLevel = 80, },
		},
		[GetSpellInfo(19750)] = { 
					["Name"] = "Flash of Light",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 1.5, BaseIncrease = true, },
					[1] = { 81, 93, 5, 5, spellLevel = 20, },
					[2] = { 124, 144, 6, 7, spellLevel = 26, },
					[3] = { 189, 211, 8, 9, spellLevel = 34, },
					[4] = { 256, 288, 9, 10, spellLevel = 42, },
					[5] = { 346, 390, 11, 11, spellLevel = 50, },
					[6] = { 445, 499, 13, 13, spellLevel = 58, },
					[7] = { 588, 658, 10, 11, spellLevel = 66, },
					[8] = { 682, 764, 0, 0, spellLevel = 74, },
					[9] = { 785, 879, 0, 0, spellLevel = 79, },
		},
		[GetSpellInfo(20473)] = { 
					["Name"] = "Holy Shock",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, Cooldown = 6, },
					[1] = { 481, 519, spellLevel = 40, },
					[2] = { 644, 696, spellLevel = 48, },
					[3] = { 845, 915, spellLevel = 56, },
					[4] = { 1061, 1149, spellLevel = 64, },
					[5] = { 1258, 1362, spellLevel = 70, },
					[6] = { 2065, 2235, spellLevel = 75, },
					[7] = { 2401, 2599, spellLevel = 80, },
					
			["Secondary"] = { 
					["Name"] = "Holy Shock",
					[0] = { School = "Holy", canCrit = true, Cooldown = 6, },
					[1] = { 314, 340, spellLevel = 40, },
					[2] = { 431, 465, spellLevel = 48, },
					[3] = { 562, 608, spellLevel = 56, },
					[4] = { 614, 664, spellLevel = 64, },
					[5] = { 904, 978, spellLevel = 70, },
					[6] = { 1043, 1129, spellLevel = 75, },
					[7] = { 1296, 1402, spellLevel = 80, },
			},
		},
		[GetSpellInfo(35395)] = {
					["Name"] = "Crusader Strike",
					[0] = { School = "Physical", Melee = true, WeaponDamage = 1.1, canCrit = true, Cooldown = 6, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(53385)] = {
					["Name"] = "Divine Storm",
					[0] = { School = "Physical", Melee = true, WeaponDamage = 4.4, canCrit = true, Cooldown = 10 },
					[1] = { 0, 0 },
		},	
		[GetSpellInfo(21084)] = {
					["Name"] = "Seal of Righteousness",
					[0] = { School = "Holy", Melee = true, SpellAPBonus = 0.044, bonusFactor = 0.022, SpellDmgBonus = true, NoCrits = true, WeaponDPS = true, NoWeapon = true, eDuration = 1800 },
					[1] = { 0 },
		},
		[GetSpellInfo(20375)] = {
					["Name"] = "Seal of Command",
					[0] = { School = "Physical", Melee = true, SpellAPBonus = 0.1035, SpellDmgBonus = true, WeaponDamage = 0.45, Hits = 120/14, eDuration = 1800, PPM = 7, NoNormalization = true, NoWeapon = true },
					[1] = { 0 },
		},
		[GetSpellInfo(31801)] = {
					["Name"] = "Seal of Vengeance",
					[0] = { School = "Holy", eDuration = 1800, SpellAPBonus = 0.078, bonusFactor = 0.15, Stacks = 5, StacksDuration = 15, NoDoom = true, NoDownRank = true },
					[1] = { 0, 0, extraDotDmg = 0, },
		},
		[GetSpellInfo(31892)] = {
					["Name"] = "Seal of Blood",
					[0] = { School = "Physical", Melee = true, SpellDmgBonus = true, WeaponDamage = 0.48, eDuration = 1800, NoNormalization = true, NoWeapon = true },
					[1] = { 0 },
		},
		[GetSpellInfo(53720)] = {
					["Name"] = "Seal of the Martyr",
					[0] = { School = "Physical", Melee = true, SpellDmgBonus = true, WeaponDamage = 0.48, eDuration = 1800, NoNormalization = true, NoWeapon = true },
					[1] = { 0 },
		},
		[GetSpellInfo(53736)] = {
					["Name"] = "Seal of Corruption",
					[0] = { School = "Holy", eDuration = 1800, SpellAPBonus = 0.078, bonusFactor = 0.15, Stacks = 5, StacksDuration = 15, NoDoom = true, NoDownRank = true },
					[1] = { 0, 0, extraDotDmg = 0, },
		},
		["Judgements"] = { [GetSpellInfo(21084)] = "Judgement of Righteousness", [GetSpellInfo(20375)] = "Judgement of Command", [GetSpellInfo(31801)] = "Judgement of Vengeance", [GetSpellInfo(53736)] = "Judgement of Corruption", [GetSpellInfo(31892)] = "Judgement of Blood", [GetSpellInfo(53720)] = "Judgement of the Martyr", [GetSpellInfo(20165)] = "Judgement of Light(s)", [GetSpellInfo(20166)] = "Judgement of Wisdom(s)", [GetSpellInfo(20164)] = "Judgement of Justice(s)" },
		[GetSpellInfo(20271)] = {
					["Name"] = "Judgement of Light",
					[0] = function()
						for k, v in pairs(DrDamage.spellInfo["Judgements"]) do
							local active, rank = UnitBuff("player", k)
							if active then
								return DrDamage.spellInfo[v][0], DrDamage.spellInfo[v][tonumber(string_match(rank,"%d+")) or 1], v
							end
						end
					end
		},
		[GetSpellInfo(53408)] = {
					["Name"] = "Judgement of Wisdom",
					[0] = function()
						for k, v in pairs(DrDamage.spellInfo["Judgements"]) do
							local active, rank = UnitBuff("player", k)
							if active then
								return DrDamage.spellInfo[v][0], DrDamage.spellInfo[v][tonumber(string_match(rank,"%d+")) or 1], v
							end
						end
					end
		},
		[GetSpellInfo(53407)] = {
					["Name"] = "Judgement of Justice",
					[0] = function()
						for k, v in pairs(DrDamage.spellInfo["Judgements"]) do
							local active, rank = UnitBuff("player", k)
							if active then
								return DrDamage.spellInfo[v][0], DrDamage.spellInfo[v][tonumber(string_match(rank,"%d+")) or 1], v
							end
						end
					end
		},
		["Judgement of Righteousness"] = {
					["Name"] = "Judgement of Righteousness",
					[0] = { School = { "Holy", "Judgement" }, SpellAPBonus = 0.32, bonusFactor = 0.2, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 1, 1 },
		},
		["Judgement of Command"] = {
					["Name"] = "Judgement of Command",
					[0] = { School = { "Holy", "Judgement", "Physical" }, WeaponDamage = 0.24, SpellAPBonus = 0.16, bonusFactor = 0.25, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 0, 0 },
		},
		["Judgement of Vengeance"] = {
					["Name"] = "Judgement of Vengeance",
					[0] = { School = { "Holy", "Judgement" }, SpellAPBonus = 0.14, bonusFactor = 0.22, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 1, 1 },
		},
		["Judgement of Corruption"] = {
					["Name"] = "Judgement of Corruption",
					[0] = { School = { "Holy", "Judgement" }, SpellAPBonus = 0.14, bonusFactor = 0.22, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 1, 1 },
		},
		["Judgement of Blood"] = {
					["Name"] = "Judgement of Blood",
					[0] = { School = { "Holy", "Judgement", "Physical" }, WeaponDamage = 0.26, SpellAPBonus = 0.18, bonusFactor = 0.11, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 0, 0 },
		},
		["Judgement of the Martyr"] = {
					["Name"] = "Judgement of the Martyr",
					[0] = { School = { "Holy", "Judgement", "Physical" }, WeaponDamage = 0.26, SpellAPBonus = 0.18, bonusFactor = 0.11, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 0, 0 },
		},
		["Judgement of Light(s)"] = {
					["Name"] = "Judgement of Light(s)",
					[0] = { School = { "Holy", "Judgement" }, SpellAPBonus = 0.16, bonusFactor = 0.25, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 1, 1 },
		},
		["Judgement of Wisdom(s)"] = {
					["Name"] = "Judgement of Wisdom(s)",
					[0] = { School = { "Holy", "Judgement" }, SpellAPBonus = 0.16, bonusFactor = 0.25, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 1, 1 },
		},
		["Judgement of Justice(s)"] = {
					["Name"] = "Judgement of Justice(s)",
					[0] = { School = { "Holy", "Judgement" }, SpellAPBonus = 0.16, bonusFactor = 0.25, Cooldown = 10, canCrit = true, NoDoom = true, NoDownRank = true, },
					[1] = { 1, 1 },
		},
		[GetSpellInfo(28880)] = {
					["Name"] = "Gift of the Naaru",
					[0] = { School = { "Holy", "Healing" }, Cooldown = 180, eDot = true, eDuration = 15, sTicks = 3, bonusFactor = 1, BaseIncrease = true, NoLowLevelPenalty = true, NoDownRank = true, NoSchoolTalents = true, },
					[1] = { 50, 50, 1185, 1185, spellLevel = 1, },
		},
		[GetSpellInfo(62124)] = { --Added 3.1
 					["Name"] = "Hand of Reckoning",
 					[0] = { School = "Holy", Cooldown = 8, bonusFactor = 0.085, canCrit = true, NoDoom = true, NoDownRank = true, NoLowLevelPenalty = true },
 					[1] = { 1, 1, spellLevel = 16 },
 		},
		[GetSpellInfo(53600)] = { 
					["Name"] = "Shield of Righteousness",
					[0] = { Offhand = select(7, GetItemInfo(40700)), canCrit = true }, --Fix for "Shields" translation
					[1] = { 390, 390, },
					[2] = { 520, 520, },
		},
        	[GetSpellInfo(53595)] = { 
					["Name"] = "Hammer of the Righteous",
					[0] = { School = "Holy", Melee = true, WeaponDamage = 12, canCrit = true, cooldown = 6 },
					[1] = { 0, 0, },
		},
	}
	self.talentInfo = { 
		--HOLY:
		--Seals of the Pure
		--Healing Light
		--Sanctified Light
        	--Holy Power
		[GetSpellInfo(20332)] = { 	[1] = { Effect = 0.03, Spells = { "Seal of Righteousness", "Judgement of Righteousness",  "Seal of Vengeance", "Judgement of Vengeance", "Seal of Corruption", "Judgement of Corruption"}, }, },
		[GetSpellInfo(20237)] = { 	[1] = { Effect = 0.04, Spells = { "Holy Light", "Flash of Light", "Holy Shock" }, }, },
		[GetSpellInfo(20359)] = { 	[1] = { Effect = 2, Spells = {"Holy Light", "Holy Shock"}, ModType = "critPerc" }, },
        	[GetSpellInfo(5923)]  = {   	[1] = { Effect = 1, Spells = "Holy", ModType = "critPerc" }, },

		--PROTECTION:
		--One-Handed Weapon Specialization
		--Touched by the Light
		[GetSpellInfo(20196)] = {	[1] = { Effect = 0.04, Melee = true, Spells = "Physical", ModType = "One-Handed Weapon Specialization" }, },		
		[GetSpellInfo(53590)] = {	[1] = { Effect = 0.1, Spells = "Healing", ModType = "critM" }, },

		--RETRIBUTION:
		--Improved Judgements
		--Crusade
		--Two-Handed Weapon Specialization
		--The Art of War
		--Fanaticism
		--Sactified Wrath
		---Righteous Vengeance
		[GetSpellInfo(25956)] = { 	[1] = { Effect = -1, Spells = "Judgement", ModType = "cooldown" }, },
		[GetSpellInfo(31866)] = { 	[1] = { Effect = 0.01, Spells = "All", ModType = "Crusade" }, },
		[GetSpellInfo(20111)] = { 	[1] = { Effect = 0.02, Melee = true, Spells = "Physical", ModType = "Two-Handed Weapon Specialization" }, },
		[GetSpellInfo(53486)] = {	[1] = { Effect = 0.05, Spells = { "Judgement", "Crusader Strike", "Divine Storm" }, }, },
		[GetSpellInfo(31879)] = { 	[1] = { Effect = 5, Spells = "Judgement", ModType = "critPerc" },
						[2] = { Effect = -0.75, Spells = "Flash of Light", ModType = "cooldown" }, },
		[GetSpellInfo(53375)] = {	[1] = { Effect = 25, Spells = "Hammer of Wrath", ModType = "critPerc" }, },
		--[GetSpellInfo(53380)] = {	[1] = { Effect = 0.05, Spells = { "Judgement", "Divine Storm" }, ModType = "critM" }, },
		---Heart of the Crusader
		--[GetSpellInfo(20335)] = { 	[1] = { Effect = 1, Spells = "All", ModType = "Amount", Value = "Heart of the Crusader" }, },
	}
end